  The grammar is called a LR(0)-{\it grammar\/} if it has
 \index{grammar!LR(0)}%
 \index{LR(0)-grammar}%
no conflicts of type shift/reduce and reduce/reduce for any
string \w{S}.

\Problem{%
     Is the grammar given above (with nonterminals \w{E} and \w{T})
a LR(0)-grammar?}

    \Solution. No, it has shift/reduce conflicts for strings
\w{T} and \w{E+T}.\es

\Problem{%
     Are the following grammars LR(0)-grammars?}
$$\begin{tabular}{ll}
  \begin{tabular}{rrcl}
     (a)&\w{T}&$\to$&\w{0}\\
        &\w{T}&$\to$&\w{T1}\\
        &\w{T}&$\to$&\w{TT2}\\
        &\w{T}&$\to$&\w{TTT3}
  \end{tabular}
&
  \begin{tabular}{rrcl}
     (b)&\w{T}&$\to$&\w{0}\\
        &\w{T}&$\to$&\w{1T}\\
        &\w{T}&$\to$&\w{2TT}\\
        &\w{T}&$\to$&\w{3TTT}
  \end{tabular}
\end{tabular}$$

    \Solution. Yes, see the corresponding tables  (a) and (b)
(no conflicts).\es

\begin{figure}[htbp]
$$
\begin{tabular}{|l|l|}
\hline
String \w{S} & $\r{State}(\w{S})$\\
\hline
empty string & $\w{}\to\_\w{0}\quad
          \w{T}\to\_\w{T1}\quad
          \w{T}\to\_\w{TT2}\quad
          \w{T}\to\_\w{TTT3}$\\
\w{0}  & $\w{}\to\w{0}\_$\\
\w{}  & $\w{}\to\w{}\_\w{1}\quad
          \w{T}\to\w{T}\_\w{T2}\quad
          \w{T}\to\w{T}\_\w{TT3}$\\
 &$       \w{}\to\_\w{0}\quad
          \w{T}\to\_\w{T1}\quad
          \w{T}\to\_\w{TT2}\quad
          \w{T}\to\_\w{TTT3}$\\
\w{T1} & $\w{T}\to\w{T1}\_$\\
\w{TT} & $\w{T}\to\w{TT}\_\w{2}\quad
          \w{T}\to\w{TT}\_\w{T3}$\\
  &$      \w{T}\to\w{T}\_\w{1}\quad
          \w{T}\to\w{T}\_\w{T2}\quad
          \w{T}\to\w{T}\_\w{TT3}$\\
&$        \w{T}\to\_\w{0}\quad
          \w{T}\to\_\w{T1}\quad
          \w{T}\to\_\w{TT2}\quad
          \w{T}\to\_\w{TTT3}$\\
\w{TT2} & $\w{T}\to\w{TT2}\_$\\
\w{TTT} & $\w{T}\to\w{TTT}\_\w{3}\quad
           \w{T}\to\w{TT}\_\w{2}\quad
           \w{T}\to\w{TT}\_\w{T3}$\\
   &$      \w{T}\to\w{T}\_\w{1}\quad
           \w{T}\to\w{T}\_\w{T2}\quad
           \w{T}\to\w{T}\_\w{TT3}$\\
&$         \w{}\to\_\w{0}\quad
           \w{T}\to\_\w{T1}\quad
           \w{T}\to\_\w{TT2}\quad
           \w{T}\to\_\w{TTT3}$\\
\w{TT0} & ${} = \w{0}$\\
\w{TTT3} & $\w{T}\to\w{TTT3}\_$\\
\w{TTT2} & $ {} = \w{TT2}$\\
\w{TTTT} & $ {}= \w{TTT}$\\
\w{TTT0} & $ {} = \w{0}$\\
\hline
\end{tabular}
$$
\begin{center}
(14.2.3, a)
\end{center}
\end{figure}


\begin{figure}[htbp]
$$
\begin{tabular}{|l|l|}
\hline
String \w{S} &          $\r{State}(\w{S})$\\
\hline
empty string &  $\w{T}\to\_\w{0}\quad
           \w{T}\to\_\w{1}\quad
           \w{T}\to\_\w{2}\quad
           \w{T}\to\_\w{3}$\\
\w{0} & $\w{}\to\w{0}\_$\\
\w{1} & $\w{}\to\w{1}\_\w{T}$\\
      & $  \w{T}\to\_\w{0}\quad
           \w{T}\to\_\w{1}\quad
           \w{T}\to\_\w{2}\quad
           \w{T}\to\_\w{3}$\\
\w{2} & $\w{T}\to\w{2}\_\w{TT}$\\
      & $  \w{T}\to\_\w{0}\quad
           \w{T}\to\_\w{1}\quad
           \w{T}\to\_\w{2}\quad
           \w{T}\to\_\w{3}$\\
\w{3} & $\w{T}\to\w{3}\_\w{TTT}$\\
      & $  \w{T}\to\_\w{0}\quad
           \w{T}\to\_\w{1}\quad
           \w{T}\to\_\w{2}\quad
           \w{T}\to\_\w{3}$\\
\w{1T} & $\w{T}\to\w{1T}\_$\\
\w{10} & ${}= \w0$\\
\w{11} & ${} = \w1$\\
\w{12} & ${} = \w2$\\
\w{13} & ${} = \w3$\\
\w{2T} & $\w{T}\to\w{2T}\_\w{T}$\\
       & $\w{T}\to\_\w{0}\quad
          \w{T}\to\_\w{1}\quad
          \w{T}\to\_\w{2}\quad
          \w{T}\to\_\w{3}$\\
\w{20} & ${} = \w0$\\
\w{21} & ${} = \w1$\\
\w{22} & ${} = \w2$\\
\w{23} & ${} = \w3$\\
\w{3T} & $\w{T}\to\w{3T}\_\w{TT}$\\
       & $\w{T}\to\_\w{0}\quad
          \w{T}\to\_\w{1}\quad
          \w{T}\to\_\w{2}\quad
          \w{T}\to\_\w{3}$\\
\w{30} & ${} = \w0$\\
\w{31} & ${} = \w1$\\
\w{32} & ${} = \w2$\\
\w{33} & ${} = \w3$\\
\w{2TT} & $\w{T}\to\w{2TT}\_$\\
\w{2T0} & ${} = \w0$\\
\w{2T1} & ${} = \w1$\\
\w{2T2} & ${} = \w2$\\
\w{2T3} & ${} = \w3$\\
\w{3TT} & $\w{T}\to\w{3TT}\_\w{T}$\\
        & $\w{T}\to\_\w{0}\quad
           \w{T}\to\_\w{1}\quad
           \w{T}\to\_\w{2}\quad
           \w{T}\to\_\w{3}$\\
\w{3T0} & ${} = \w0$\\
\w{3T1} & ${} = \w1$\\
\w{3T2} & ${} = \w2$\\
\w{3T3} & ${} = \w3$\\
\w{3TTT}& $\w{T}\to\w{3TTT}\_$\\
\w{3TT0} & ${} = \w0$\\
\w{3TT1} & ${} = \w1$\\
\w{3TT2} & ${} = \w2$\\
\w{3TT3} & ${} = \w3$\\
\hline
\end{tabular}$$
\begin{center}
(14.2.3, b)
\end{center}
\end{figure}

     This problem shows that LR(0)-grammars may be left-recursive
as well as right-recursive.

\Problem{%
     Assume that an LR(0)-grammar is given. Prove that each
string has at most one rightmost derivation. Give an
algorithm that checks whether the input string is derivable.}

    \Solution. Assume that an arbitrary input string is given.
We construct an LR-process on that string stepwise.
Assume that the current
stack of the LR-process is \w{S}. We have to decide whether a
shift or reduce action is needed (and
which rule should be used in the reduction case).
The definition of LR(0)-grammar guarantees that
only one action is possible, and all the information needed to
make the decision is
contained
in $\r{State}(\w{S})$.
Therefore, we can find the (only possible) next step of the
LR-process.\es

\Problem{%
     What happens if the input string has no derivation in the
grammar?}

    Answer. There are two possibilities: (1) neither a shift nor a
reduce action will be possible at some point;
(2) all possible shifts have the next symbol different from the
actual one.\es

\smallskip

    Remarks. {\bf 1}. When implementing this algorithm, there is
no need to compute the set
$\r{State}(\w{S})$ from scratch for each value of
\w{S}. These sets may be kept in a stack. (At any point
we keep on the stack the sets
$\r{State}(\w{T})$ for all prefixes \w{T} of the current value of
\w{S}.)

     {\bf 2}. In fact, the string \w{S} itself is not used at
all. It is enough to keep the sets $\r{State}(\w{T})$ for all
its prefixes \w{T} (including \w{S} itself).

\medskip


