
     Now the queens problem can be divided in two parts:
(1) how to traverse all the vertices of a given tree;
(2) how to represent
the tree of admissible positions for the
queens problem using Pascal constructs.

     Let us formulate the general problem of visiting all the
vertices of a given
tree. Imagine there is a robot that can be placed
at any vertex of a tree.
 \index{tree!traversal}%
(Vertices are shown as small circles in our pictures.)
The repertoire of the robot consists of the following commands:
\begin{itemize}
\item             \verb|up_left| (``move along the up-left arrow'')
\item             \verb|right| (``move to the right neighbor'')
\item             \verb|down| (``move down one level'')
\end{itemize}
(The pictures below show which movements correspond to these commands.)
\setbox0\hbox{\protect\verb|up_left|}
\[
\setlength{\unitlength}{12pt}
\begin{picture}(8,8)
\put(0,0){\makebox(6,1){\box0}}
\thinlines
\put(3,1){\circle*{.2}}
  \put(3,1){\line(-1,1){2}}
  \put(3,1){\line(0,1){2}}
  \put(3,1){\line(1,1){2}}
\put(1,3){\circle*{.2}}
\put(3,3){\circle*{.2}}
  \put(3,3){\line(-1,2){1}}
  \put(3,3){\line(0,1){2}}
  \put(3,3){\line(1,2){1}}
\put(5,3){\circle*{.2}}
  \put(5,3){\line(0,1){2}}
  \put(5,3){\line(1,2){1}}
  \put(5,3){\line(1,1){2}}
\put(2,5){\circle*{.2}}
\put(3,5){\circle*{.2}}
\put(4,5){\circle*{.2}}
\put(5,5){\circle*{.2}}
  \put(5,5){\line(-1,1){2}}
  \put(5,5){\line(-1,2){1}}
  \put(5,5){\line(0,1){2}}
  \put(5,5){\line(1,2){1}}
\put(6,5){\circle*{.2}}
\put(7,5){\circle*{.2}}
\put(3,7){\circle*{.2}}
\put(4,7){\circle*{.2}}
\put(5,7){\circle*{.2}}
\put(6,7){\circle*{.2}}
  \thicklines
  \put(3,1){\vector(-1,1){2}}
  \put(3,3){\vector(-1,2){1}}
  \put(5,3){\vector(0,1){2}}
  \put(5,5){\vector(-1,1){2}}
\end{picture}%
\quad
\begin{picture}(8,8)
\put(0,0){\makebox(6,1){\verb|right|}}
\thinlines
\put(3,1){\circle*{.2}}
  \put(3,1){\line(-1,1){2}}
  \put(3,1){\line(0,1){2}}
  \put(3,1){\line(1,1){2}}
\put(1,3){\circle*{.2}}
\put(3,3){\circle*{.2}}
  \put(3,3){\line(-1,2){1}}
  \put(3,3){\line(0,1){2}}
  \put(3,3){\line(1,2){1}}
\put(5,3){\circle*{.2}}
  \put(5,3){\line(0,1){2}}
  \put(5,3){\line(1,2){1}}
  \put(5,3){\line(1,1){2}}
\put(2,5){\circle*{.2}}
\put(3,5){\circle*{.2}}
\put(4,5){\circle*{.2}}
\put(5,5){\circle*{.2}}
  \put(5,5){\line(-1,1){2}}
  \put(5,5){\line(-1,2){1}}
  \put(5,5){\line(0,1){2}}
  \put(5,5){\line(1,2){1}}
\put(6,5){\circle*{.2}}
\put(7,5){\circle*{.2}}
\put(3,7){\circle*{.2}}
\put(4,7){\circle*{.2}}
\put(5,7){\circle*{.2}}
\put(6,7){\circle*{.2}}
%\thicklines   - thicklines make arrows invisible
\put(1,3){\vector(1,0){2}}
\put(3,3){\vector(1,0){2}}
\put(2,5){\vector(1,0){1}}
\put(3,5){\vector(1,0){1}}
\put(5,5){\vector(1,0){1}}
\put(6,5){\vector(1,0){1}}
\put(3,7){\vector(1,0){1}}
\put(4,7){\vector(1,0){1}}
\put(5,7){\vector(1,0){1}}

\end{picture}
\begin{picture}(8,8)
\put(0,0){\makebox(6,1){\verb|down|}}
\thinlines
\put(3,1){\circle*{.2}}
\put(1,3){\circle*{.2}}
  \put(1,3){\vector(1,-1){1}}
\put(3,3){\circle*{.2}}
  \put(3,3){\vector(0,-1){1}}
\put(5,3){\circle*{.2}}
  \put(5,3){\vector(-1,-1){1}}
\put(2,5){\circle*{.2}}
  \put(2,5){\vector(1,-2){.5}}
\put(3,5){\circle*{.2}}
  \put(3,5){\vector(0,-1){1}}
\put(4,5){\circle*{.2}}
  \put(4,5){\vector(-1,-2){.5}}
\put(5,5){\circle*{.2}}
  \put(5,5){\vector(0,-1){1}}
\put(6,5){\circle*{.2}}
  \put(6,5){\vector(-1,-2){.5}}
\put(7,5){\circle*{.2}}
  \put(7,5){\vector(-1,-1){1}}
\put(3,7){\circle*{.2}}
  \put(3,7){\vector(1,-1){1}}
\put(4,7){\circle{.2}}
  \put(4,7){\vector(1,-2){.5}}
\put(5,7){\circle*{.2}}
  \put(5,7){\vector(0,-1){1}}
\put(6,7){\circle*{.2}}
  \put(6,7){\vector(-1,-2){.5}}
\thicklines
  \put(1,3){\line(1,-1){2}}
  \put(3,3){\line(0,-1){2}}
  \put(5,3){\line(-1,-1){2}}
  \put(2,5){\line(1,-2){1}}
  \put(3,5){\line(0,-1){2}}
  \put(4,5){\line(-1,-2){1}}
  \put(5,5){\line(0,-1){2}}
  \put(6,5){\line(-1,-2){1}}
  \put(7,5){\line(-1,-1){2}}
  \put(3,7){\line(1,-1){2}}
  \put(4,7){\line(1,-2){1}}
  \put(5,7){\line(0,-1){2}}
  \put(6,7){\line(-1,-2){1}}
\end{picture}
\]
Moreover, the robot's repertoire includes tests that check
whether each command can be executed:
\begin{itemize}
\item \verb|is_up|;
\item \verb|is_right|;
\item  \verb|is_down|;
\end{itemize}
(the last test returns \w{True} everywhere except at the root).
Please note that the \w{right} command allows a move from the
vertex to its ``brother'' but not to its ``cousin''
having only a grandfather in common.
\[
\setlength{\unitlength}{1.2em}
\begin{picture}(14,6)
\thinlines
\put(4,1){\circle*{.2}}
  \put(4,1){\vector(-1,1){2}}
  \put(4,1){\vector(1,1){2}}
\put(2,3){\circle*{.2}}
  \put(2,3){\vector(-1,2){1}}
  \put(2,3){\vector(1,2){1}}
\put(6,3){\circle*{.2}}
  \put(6,3){\vector(-1,2){1}}
  \put(6,3){\vector(1,2){1}}
\put(1,5){\circle*{.2}}
\put(3,5){\circle*{.2}}
\put(5,5){\circle*{.2}}
\put(7,5){\circle*{.2}}
\thicklines
\put(3,5){\vector(1,0){2}}
\thinlines
\put(3.5,4.5){\line(1,1){1}}
\put(4.5,4.5){\line(-1,1){1}}
\put(9,4){\makebox(6,1){\strut\r{This is {\bf not}}}}
\put(9,3){\makebox(6,1){\strut\r{a valid}}}
\put(9,2){\makebox(6,1){\strut\r{\w{right} move!}}}
\end{picture}
\]

     Finally, we assume that the
robot is able to perform a command
\w{process}. Our goal is to process (that is, to execute the
command \w{process})
all leaves of the tree
(a {\it leaf\/} is a vertex such that \verb|is_up| is false,
that is, a vertex with
no descendants). In our chess problem, \w{process} means to check the
position and to print it (if it contains \w{n} queens not attacking
each other).

     Remark.
Our trees have root at the bottom.
Please note that in most computer science books trees are drawn
with the root
at the {\it top}. While it seems to be nonintuitive, it is the
de facto standard.

     The proof of the program below uses the following conventions.
Assume that the position of the robot is fixed. Then all the leaves of the
tree are divided into three categories: (1) leaves {\it above}
the robot; (2) leaves {\it on the left} of the robot and (3) leaves
{\it on the right} of the robot.
Indeed, the (unique) path from the root to a given leaf (a) may go through
the robot's position; (b) may turn to the left before the robot's
position, or (c) may go to the right before it.
By (LP) we denote the condition ``all the leaves on the
left of the robot are processed''; by (LAP) we denote the
condition ``all the leaves on the left of the robot
and above it are processed''. (In both cases we require that
no other leaves are processed.)
\[
\setlength{\unitlength}{1.2em}
\begin{picture}(12,8)
\thinlines
\put(6,1){\circle*{0.2}}
\put(7,4){\circle*{0.2}}
\put(6,1){\line(-1,1){5}}
\put(6,1){\line(1,1){5}}
\put(1,6){\line(1,0){10}}
\thicklines
\put(6,1){\line(1,3){1}}
\put(7,4){\line(-1,1){2}}
\put(7,4){\line(1,2){1}}
\put(5,6){\line(1,0){3}}
\put(1,6){\makebox(4,1){\strut\r{Left}}}
\put(5,6){\makebox(3,1){\strut\r{Above}}}
\put(8,6){\makebox(3,1){\strut\r{Rignt}}}
\end{picture}
\]
We will use the following procedure:
\begin{verbatim}
  procedure go_up_and_process;
  | {before: (LP), after: (LAP)}
  begin
  | {invariant: LP}
  | while is_up do begin
  | | up_left;
  | end
  | {LP, current position is a leaf}
  | process;
  | {LAP}
  end;
\end{verbatim}

Here is the main program:

\begin{verbatim}
  before: robot is in the root, no leaves are processed
  after: robot is in the root, all leaves are processed

  {LP}
  go_up_and_process;
  {invariant: LAP}
  while is_down do begin
  | if is_right then begin {LAP, is_right}
  | | right;
  | | {LP}
  | | go_up_and_process;
  | end else begin
  | | {LAP, not is_right, is_down}
  | | down;
  | end;
  end;
  {LAP, current position is root => all leaves are processed}
\end{verbatim}


Correctness now follows from the properties of
the robot's  commands. They are presented below in the format:
\begin{center}
\{precondition\}~command~\{postcondition\};
\end{center}
The postcondition is guaranteed after execution of the command,
assuming that the precondition was true before.

   (1) \quad\{LP, not \verb|is_up|\}
       \w{process}
      \{LAP\}

   (2) \quad \{LP\}
       \verb|up_left|
       \{LP\}

   (3) \quad \{\verb|is_right|, LAP\}
       \w{right}
       \{LP\}

   (4) \quad \{not~\verb|is_right|, \verb|is_down|, LAP\}
       \w{down}
       \{LAP\}


