\subsection{Applications of sorting}

\Problem{%
     Find the number of different elements in an integer array.
The number of operations should be of order
$n\log n$. (This problem was already mentioned in
section~\ref{start}.)}%
 \index{number!of different elements}%

     \Solution. Sort the array and then count the different elements
going from left to right.\es

\Problem{%
   Suppose that \w{n} closed intervals $[\w{a[i]},\w{b[i]}]$ on
the real line are given ($\w{i}=\w{1..n}$). Find the
maximal \w{k} such that there exists a point
covered by \w{k} intervals (the ``maximal thickness'' of
covering).
The number of operations should be of order
$\w{n}\log\w{n}$. }

     \Hint{Sort all the left and right endpoints of the intervals
together.
While sorting, assume that the left endpoint precedes the right
endpoint located at the same point of the real line.
Then move from left to right counting the number of layers. When
we cross the left endpoint, increase the number of layers by
$1$; when
we cross the right endpoint, decrease the number of layers by $1$.
Please note that two adjacent intervals are processed correctly; that is,
the
left endpoint precedes the right endpoint
according to our convention.}

\Problem{%
      Assume that \w{n} points in the plane are given. Find a polygonal arc
with $\,\w{n}-\w{1}\,$ sides whose vertices are the given points,
and whose sides do not intersect. (Adjacent sides may
form a $180^{\circ}$ angle.) The number of operations should be of
order $\w{n}\log\w{n}$.}

     \Solution. Sort all the points with respect to the
$x$-coordinate; when $x$-coordinates are equal, take the
$y$-coordinate
into account, then connect all vertices by line segments (in that order).\es

\Problem{%
     The same problem for a polygon: for a given set of points in the plane
find a polygon having these points as vertices.}

     \Solution. Take the leftmost point (the point whose
$x$-coordinate is minimal). Consider all the rays starting from this point
and going through all other points. Sort these rays according to
their slopes, and sort the points
that are on the same ray according to their
distance from the initial point.
Do this for all rays except the rays with
maximal and minimal slopes. The polygon goes from the initial point along the
ray with minimal slope, then visits all the points in the order chosen,
returning via the ray with maximal slope.\es

\Problem{%
     Assume that \w{n} points in the plane are given. Find their
{\it convex
hull}, that is, the minimal convex polygon that contains all the
points. (A rubber band put on the nails is the convex hull of
the nails inside it.) The number of operations should be of
order $\w{n}\log\w{n}$.}%
 \index{convex hull}%
   \Hint{Order all the points according to one of the
orderings mentioned in the two preceding problems. Then construct
the convex hull considering the points one by one.
(To maintain information about the current convex hull, it is useful
to use a deque; see section~\ref{types}, page~\pageref{deque}.
It is not necessary,
however, when the points are ordered according to their
slopes.)}

